public class Action
{
      public static final int REVEAL = 2, ADD = 3, SPLIT = 4,
	 DELETE = 5;
      private int type;
      private String arg1, arg2, arg3, arg4;

      private Action(int type, String arg1, String arg2, String arg3, String arg4)
      {
	 this.type = type;
	 this.arg1 = arg1;
	 this.arg2 = arg2;
	 this.arg3 = arg3;
	 this.arg4 = arg4;
      }


      public static Action revealUnit(String stack, String unit, String numRevealed)
      {
	 return revealUnit(stack,unit,null,numRevealed);
      }
      public static Action revealUnit(String stack, String unit, String player, String numRevealed)
      {
	 return new Action(REVEAL, stack, unit, player, numRevealed);
      }

      public static Action add(String stack, String unit)
      {
	 return new Action(ADD, stack, unit, null, null);
      }
	 
      public static Action splitStack(String oldStack, String newStack, String newSize)
      {
	 return new Action(SPLIT, oldStack, newStack, newSize, null);
      }

      public static Action delete(String stack, String unit)
      {
	 return new Action(DELETE, stack, unit, null, null);
      }

      public void implement()
      {
	 if(type == REVEAL)
	    Titan.revealUnit(arg1,arg2,arg3,arg4);
	 else if(type == ADD && arg2 == null)
	    Titan.addStack(arg1);
	 else if(type == ADD)
	    Titan.addUnit(arg1,arg2);
	 else if(type == SPLIT)
	    Titan.splitStack(arg1,arg2,Integer.parseInt(arg3));
	 else if(type == DELETE && arg2 == null)
	    Titan.deleteStack(arg1);
	 else if(type == DELETE)
	    Titan.deleteUnit(arg1,arg2);
	 else
	 {
	    Titan.err("Spurious type in Action: " + type);
	    System.exit(82);
	 }
      }

      public String toString()
      {
	 if(type == REVEAL)
	    return "reveal " + arg1 + " " + (arg4 == null ? "" : arg4 + " ")
	       + arg2 + (arg3 == null ? "" : (" " + arg3));
	 else if(type == ADD)
	    return "add " + arg1 + (arg2 == null ? "" : (" " + arg2));
	 else if(type == SPLIT)
	    return "split " + arg1 + " " + arg2 + " " + arg3;
	 else if(type == DELETE && arg2 == null)
	    return "delete " + arg1;
	 else if(type == DELETE)
	    return "delete " + arg1 + " " + arg2;
	 else
	 {
	    Titan.err("Spurious type in Action: " + type);
	    System.exit(82);
	 }
	 return null;
      }

}