import java.util.ArrayList;
import java.util.Iterator;
import java.util.Hashtable;
import java.util.Collection;
import java.util.StringTokenizer;

public class Unit
{
      // the type of the unit
      private int type;

      // the stacks that this unit could be in
      private Collection[] stacklist;

      public Unit(int type, Stack initialStack)
      {
	 this.type = type;
	 stacklist = new Collection[Titan.numPlayers + 1];
	 for(int i = 0 ; i < stacklist.length ; i++)
	 {
	    stacklist[i] = new ArrayList();
	    stacklist[i].add(initialStack);
	 }
      }

      public int getNumStacks(int player)
      {
	 return stacklist[player].size();
      }

      public void setStack(Stack stack, int player)
      {
	 Iterator it = stacklist[player].iterator();
	 while(it.hasNext())
	    ((Stack)it.next()).removeUnit(this,player);
	 stacklist[player].clear();
	 stacklist[player].add(stack);
	 stack.addUnit(this, player);	 
      }

      public void setStackNot(Stack stack, int player)
      {
	 stacklist[player].remove(stack);
      }

      public int getType()
      {
	 return type;
      }

      public String getName()
      {
	 String name = Titan.getNameFromUnitType(type);
	 if(name == null)
	    Titan.err("Name not found for creature type " + type + " BAD");

	 return name;
      }

      public void alsoIn(Stack s, int p)
      {
	 stacklist[p].add(s);
      }
}